//A union of three tori with a glass ball in the center
//looking down a tall, skinny cylinder cutting through a ball
//that looks like the sky. And a bunch of little spheres around 
//the base.
//Blane Bizzaro

#include "colors.inc"
#include "shapes.inc"
#include "textures.inc"
#include "env01.inc"

camera {
   location  <-3, 21, 0>
   direction <0, 0, 1>
   up        <0, 1, 0> 
   right     <1.33333, 0, 0>
   look_at   <0, 0, 0>
}

light_source { <800, 600, -200> color White }

light_source { <-10, 5.8, -7> color Orange }

light_source { <10, 5.8, -7> color Green }

//Sphere in the center of torus union.
sphere { <0, 0, 0>, 3
   texture { Glass3 finish { reflection 0.25}}
}

//Torus union 
object {
   union {
   object {
      torus { 4.5, 0.3 sturm }
         texture { Brown_Agate finish { reflection 0.25 }}
         }
   object {
      torus  { 4.5, 0.3 sturm }
         texture { Jade finish {reflection 0.25 }}
         rotate <0, 0, 90>
      }
   object {
      torus { 4.5, 0.3 sturm }
         texture { Glass3 finish { reflection 0.25 }}
         rotate <0, 0, 90>
         rotate <0, 90, 0>
         }
//Vertical cylinder cutting through "sky" sphere.
   object {
      cylinder {
         <0, 30, 0>
         <0, -30, 0>
         0.3 //radius
         pigment { color red 1 blue 1 green 1 }}
         }
//"sky" sphere.
   object {
      sphere { <0, 14, 0>, 1.5
         pigment {
            bozo
            turbulence 0.6
            color_map {
            [0 0.5   color red 0.4 green 0.5 blue 1
                     color red 0.4 green 0.5 blue 1.0]
            [0.5 0.7 color red 0.4 green 0.5 blue 1
                     color red 1 green 1 blue 1.0]
            [0.7 1   color red 1 green 1 blue 1
                     color red 0.7 green 0.7 blue 0.7]}
             quick_color red 0.4 green 0.5 blue 1
             }
             finish {
             ambient 0.9
             diffuse 0
             }
       }
}
//orbital spheres (#1)
sphere { <0, 0, 7>,1
   pigment {
      bozo
      turbulence 0.6
      color_map {
      [0 0.5   color red 0.4 green 0.5 blue 1
               color red 0.4 green 0.5 blue 1.0]
      [0.5 0.7 color red 0.4 green 0.5 blue 1
               color red 1 green 1 blue 1]
      [0.7 1   color red 1 green 1 blue 1
               color red 0.7 green 0.7 blue 0.7]}
               quick_color red 0.4 green 0.5 blue 1
               }
               finish {
               ambient 0.9
               diffuse 0
               }
         }

}}
//sphere #2
sphere { <5, 0, 5>, 1
   pigment { color Orange }
   finish {
   reflection 0.45
   ambient 0.2
   diffuse 0.6
   phong 1.0 phong_size 80
       }}
       
//sphere #3
sphere { <7, 0, 0>, 1
   pigment {
      bozo
      turbulence 0.6
      color_map {
      [0 0.5   color red 0.4 green 0.5 blue 1
               color red 0.4 green 0.5 blue 1]
      [0.5 0.7 color red 0.4 green 0.5 blue 1
               color red 1 green 1 blue 1]
      [0.7 1   color red 1 green 1 blue 1
               color red 0.7 green 0.7 blue 0.7]}
               quick_color red 0.4 green 0.5 blue 1
               }
               finish {
               ambient 0.9
               diffuse 0
               }
       }
//sphere #4
sphere { <5, 0, -5>, 1
   pigment {
      bozo
      turbulence 0.6
      color_map {
      [0 0.5   color red 0.4 green 0.5 blue 1
               color red 0.4 green 0.5 blue 1]
      [0.5 0.7 color red 0.4 green 0.5 blue 1
               color red 1 green 1 blue 1]
      [0.7 1   color red 1 green 1 blue 1
               color red 0.7 green 0.7 blue 0.7]}
               quick_color red 0.4 green 0.5 blue 1
               }
               finish {
               ambient 0.9
               diffuse 0
               }
        }
//sphere #5
sphere { <0, 0, -7>, 1
  texture { Glass3 finish { reflection 0.25}}
       }        
         
//sphere #6
sphere { <-5, 0, -5>, 1
   pigment { color Red }
   finish {
      reflection 0.45
      ambient 0.2
      diffuse 0.6
      phong 1.0 phong_size 80
      }}

   
//sphere #7
sphere { <-7, 0, 0>, 1
   texture {Jade}}
   
//sphere #8
sphere { <-5, 0, 5>, 1
   pigment { color Yellow }}
   

   


      
     
